// S1, S2, S3, and M are all constants, and z is part of the  
    // private per-thread generator state.  
__device__ unsigned TausStep(unsigned &z, int S1, int S2, int S3, unsigned M)  
 {  
   unsigned b=(((z << S1) ^ z) >> S2);  
   return z = (((z & M) << S3) ^ b);  
 }  




 // A and C are constants  
 __device__   unsigned LCGStep(unsigned &z, unsigned A, unsigned C)  
 {  
   return z=(A*z+C);  
 }  



   
__device__ FLOAT HybridTaus(unsigned (*seed_d1),unsigned (*seed_d2),unsigned (*seed_d3),unsigned (*seed_d4), const unsigned int id)  
 {  

       unsigned z1=seed_d1[id]; unsigned z2=seed_d2[id]; unsigned z3=seed_d3[id]; unsigned z4=seed_d4[id]; 
   // Combined period is lcm(p1,p2,p3,p4)~ 2^121  
    
    FLOAT rr= 2.3283064365387e-10 * (              // Periods  
     TausStep(z1, 13, 19, 12, 4294967294UL) ^  // p1=2^31-1  
     TausStep(z2, 2, 25, 4, 4294967288UL) ^    // p2=2^30-1  
     TausStep(z3, 3, 11, 17, 4294967280UL) ^   // p3=2^28-1  
     LCGStep(z4, 1664525, 1013904223UL)        // p4=2^32  
    );
    seed_d1[id]=z1;seed_d2[id]=z2;seed_d3[id]=z3;seed_d4[id]=z4;
    return rr;
 }  

// S1, S2, S3, and M are all constants, and z is part of the  
    // private per-thread generator state.  
 unsigned TausStepH(unsigned &z, int S1, int S2, int S3, unsigned M)  
 {  
   unsigned b=(((z << S1) ^ z) >> S2);  
   return z = (((z & M) << S3) ^ b);  
 }  




 // A and C are constants  
   unsigned LCGStepH(unsigned &z, unsigned A, unsigned C)  
 {  
   return z=(A*z+C);  
 }  



   unsigned z1H=(int)time(0), z2H=100, z3H=101, z4H;
  
 FLOAT HybridTausH( )  
 {   
   // Combined period is lcm(p1,p2,p3,p4)~ 2^121  
    return 2.3283064365387e-10 * (              // Periods  
     TausStepH(z1H, 13, 19, 12, 4294967294UL) ^  // p1=2^31-1  
     TausStepH(z2H, 2, 25, 4, 4294967288UL) ^    // p2=2^30-1  
     TausStepH(z3H, 3, 11, 17, 4294967280UL) ^   // p3=2^28-1  
     LCGStepH(z4H, 1664525, 1013904223UL)        // p4=2^32  
    );  
 }  

__global__ void Htest(unsigned (*seed_d1),unsigned (*seed_d2),unsigned (*seed_d3),unsigned (*seed_d4), const unsigned int id, FLOAT (*rr)){

  
   rr[0]=HybridTaus(seed_d1,seed_d2,seed_d3,seed_d4,id);

}


