__global__ void FluxUpdate(FLOAT (*cm), FLOAT (*cs), FLOAT (*cj), FLOAT (*cd), int (*dfun), int (*Nr), int (*Nl), int (*nr), FLOAT (*Ilcc), FLOAT (*Iryr), FLOAT (*Jncx), const FLOAT Nai3value, const FLOAT v, const FLOAT mdt, const unsigned int nxnynz, const FLOAT t){
///////update buffers, flux

const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  
 assert(false);
if (idx<nxnynz){
  
  const FLOAT BuffM=1.0+BcdKcd/POW(cm[idx]+Kcd,2)+BsrKsr/POW(cm[idx]+Ksr,2);
  const FLOAT BuffS=1.0+BnsrKnsr/POW(cs[idx]+Knsr,2);
  const FLOAT Jup=vup*POW(cm[idx],2)/(POW(cm[idx],2)+POW(kup,2));
  const FLOAT Jleak=gleak*(cs[idx]-cm[idx]);
  #ifdef gbgconst
  const FLOAT Jbg=(-gca*(v-LOG(cao/cm[idx])/F_RT/2.0))+(90.0*gbgconst);
  #else
  const FLOAT Jbg=(-gca*(v-LOG(cao/cm[idx])/F_RT/2.0));
  #endif
  
  const FLOAT Enai3= Nai3value;
  
  
   if (dfun[idx] == 1 && nr[idx]==Nryr){
    
    const FLOAT phi=v*F_RT;
    Jncx[idx]=v2*(EXP(nu*phi)*Enai3*Cao-EXP((nu-1.0)*phi)*Nao3*cm[idx])/(1.0+POW(Kmca/(cm[idx]),3))/(1.0+ksat*EXP((nu-1.0)*phi))/(Kmco*Enai3+Kmno3*cm[idx]+Kmni3*Cao*(1.0+cm[idx]/Kmci)+Kmci*Nao3*(1.0+Enai3/Kmni3)+Enai3*Cao+Nao3*cm[idx]);
    
    const FLOAT BuffJ=1.0+BnsrKnsr/POW(cj[idx]+Knsr,2);
                Iryr[idx]=(Nr[idx])*gryr*(cj[idx]-cd[idx]);
    const FLOAT FluxJ=(gjsr*(cs[idx]-cj[idx])-(Iryr[idx])/Vj)/BuffJ;
                

    const FLOAT FluxS=(kappa*(Jup-Jleak)-gjsr*(cs[idx]-cj[idx])*(Vj/zetas))/BuffS;
    const FLOAT FluxM=(-Jup+Jncx[idx]+Jbg+Jleak+gds*(cd[idx]-cm[idx])*(Vd/zetam))/BuffM;
              

    if (abs(phi)>0.01) {
     Ilcc[idx]=Nl[idx]*glcc*Pca*2*phi*(Bca*Cao-EXP(2.0*phi)*cd[idx])/(EXP(2.0*phi)-1.0);
     
     cd[idx]=(-(Vd*gds)*cm[idx]-(Nr[idx])*(gryr)*cj[idx]-Nl[idx]*(glcc)*Pca*2.0*phi*Bca*Cao/(EXP(2.0*phi)-1.0))/(-(Vd*gds)-(Nr[idx])*(gryr)-Nl[idx]*(glcc)*Pca*2.0*phi*EXP(2.0*phi)/(EXP(2.0*phi)-1.0));

     //cd[idx]=(-(Vd*gds)*cm[idx]-(Nr[idx])*(gryr)*cj[idx]-Nl[idx]*(glcc)*Pca*2*phi*Bca*Cao/(EXP(2*phi)-1))/(-(Vd*gds)-(Nr[idx])*(gryr)-Nl[idx]*(glcc)*Pca*2*phi*EXP(2*phi)/1000.0/(EXP(2*phi)-1));

    }
    else {
     Ilcc[idx]=Nl[idx]*glcc*Pca*(Bca*Cao-EXP(2.0*phi)*cd[idx]);
     
     cd[idx]=(-(Vd*gds)*cm[idx]-(Nr[idx])*(gryr)*cj[idx]-Nl[idx]*(glcc)*Pca*Bca*Cao)/(-(Vd*gds)-(Nr[idx])*(gryr)-Nl[idx]*(glcc)*Pca*EXP(2.0*phi));

    //cd[idx]=(-(Vd*gds)*cm[idx]-(Nr[idx])*(gryr)*cj[idx]-Nl[idx]*(glcc)*Pca*Bca*Cao)/(-(Vd*gds)-(Nr[idx])*(gryr)-Nl[idx]*(glcc)*Pca*EXP(2*phi))/1000.0;
    };
      //FluxD=( -gds*(cd[idx]-cm[idx]) + Nr[idx]*gryr*(cj[idx]-cd[idx])/Vd + Ilcc[idx]/Vd );  
      #ifndef FIX_SR 
        cj[idx]=cj[idx]+mdt*FluxJ; 
        cs[idx]=cs[idx]+mdt*FluxS;
      #endif
        cm[idx]=cm[idx]+mdt*FluxM;
      
      
    
   }
  
   else if(dfun[idx] == 1 && nr[idx]!=Nryr){


    const FLOAT phi=v*F_RT;
    Jncx[idx]=v2*(EXP(nu*phi)*Enai3*Cao-EXP((nu-1)*phi)*Nao3*cm[idx])/(1+POW(Kmca/(cm[idx]),3))/(1+ksat*EXP((nu-1)*phi))/(Kmco*Enai3+Kmno3*cm[idx]+Kmni3*Cao*(1+cm[idx]/Kmci)+Kmci*Nao3*(1+Enai3/Kmni3)+Enai3*Cao+Nao3*cm[idx]);
      
    if (abs(phi)>0.01) {
     Ilcc[idx]=Nl[idx]*glcc*Pca*2*phi*(Bca*Cao-EXP(2.0*phi)*cm[idx])/(EXP(2.0*phi)-1.0);
    }
    else {
     Ilcc[idx]=Nl[idx]*glcc*Pca*(Bca*Cao-EXP(2.0*phi)*cm[idx]);
    };

      const FLOAT FluxS=(kappa*(Jup-Jleak))/BuffS;
      const FLOAT FluxM=(-Jup+Jncx[idx]+Jbg+Jleak+Ilcc[idx]/zetam)/BuffM;
                cm[idx]=cm[idx]+mdt*FluxM;
               #ifndef FIX_SR 
	        cs[idx]=cs[idx]+mdt*FluxS;
               #endif

   }

   else{

    const FLOAT phi=v*F_RT;
    Jncx[idx]=v2*(EXP(nu*phi)*Enai3*Cao-EXP((nu-1)*phi)*Nao3*cm[idx])/(1+POW(Kmca/(cm[idx]),3))/(1+ksat*EXP((nu-1)*phi))/(Kmco*Enai3+Kmno3*cm[idx]+Kmni3*Cao*(1+cm[idx]/Kmci)+Kmci*Nao3*(1+Enai3/Kmni3)+Enai3*Cao+Nao3*cm[idx]);
      
      const FLOAT FluxS=(kappa*(Jup-Jleak))/BuffS;
      const FLOAT FluxM=(-Jup+Jncx[idx]+Jbg+Jleak)/BuffM;
                cm[idx]=cm[idx]+mdt*FluxM;
               #ifndef FIX_SR 
	        cs[idx]=cs[idx]+mdt*FluxS;
               #endif

 
        
 };
};

}


//////////  for ryr ode  //////////////////////

__global__ void FluxUpdate_RYR_ODE(FLOAT (*cm), FLOAT (*cs), FLOAT (*cj), FLOAT (*cd), int (*dfun), FLOAT (*Pro), int (*Nl), int (*nr), FLOAT (*Ilcc), FLOAT (*Iryr), FLOAT (*Jncx), const FLOAT Nai3value, const FLOAT v, const FLOAT mdt, const unsigned int nxnynz, const FLOAT t){
	///////update buffers, flux
	
	const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  
	
	if (idx<nxnynz){
		
		const FLOAT BuffM=1.0+BcdKcd/POW(cm[idx]+Kcd,2)+BsrKsr/POW(cm[idx]+Ksr,2);
		const FLOAT BuffS=1.0+BnsrKnsr/POW(cs[idx]+Knsr,2);
		const FLOAT Jup=vup*POW(cm[idx],2)/(POW(cm[idx],2)+POW(kup,2));
		const FLOAT Jleak=gleak*(cs[idx]-cm[idx]);
#ifdef gbgconst
		const FLOAT Jbg=(-gca*(v-LOG(cao/cm[idx])/F_RT/2.0))+(90.0*gbgconst);
#else
		const FLOAT Jbg=(-gca*(v-LOG(cao/cm[idx])/F_RT/2.0));
#endif
		
		const FLOAT Enai3= Nai3value;
		
		
		if (dfun[idx] == 1){
			
			const FLOAT phi=v*F_RT;
			Jncx[idx]=v2*(EXP(nu*phi)*Enai3*Cao-EXP((nu-1.0)*phi)*Nao3*cm[idx])/(1.0+POW(Kmca/(cm[idx]),3))/(1.0+ksat*EXP((nu-1.0)*phi))/(Kmco*Enai3+Kmno3*cm[idx]+Kmni3*Cao*(1.0+cm[idx]/Kmci)+Kmci*Nao3*(1.0+Enai3/Kmni3)+Enai3*Cao+Nao3*cm[idx]);
			
			const FLOAT BuffJ=1.0+BnsrKnsr/POW(cj[idx]+Knsr,2);
			Iryr[idx]=(Pro[idx]*Nryr)*gryr*(cj[idx]-cd[idx]);
			const FLOAT FluxJ=(gjsr*(cs[idx]-cj[idx])-(Iryr[idx])/Vj)/BuffJ;
			
			
			const FLOAT FluxS=(kappa*(Jup-Jleak)-gjsr*(cs[idx]-cj[idx])*(Vj/zetas))/BuffS;
			const FLOAT FluxM=(-Jup+Jncx[idx]+Jbg+Jleak+gds*(cd[idx]-cm[idx])*(Vd/zetam))/BuffM;
			
			
			if (abs(phi)>0.01) {
				Ilcc[idx]=Nl[idx]*glcc*Pca*2*phi*(Bca*Cao-EXP(2.0*phi)*cd[idx])/(EXP(2.0*phi)-1.0);
				
				cd[idx]=(-(Vd*gds)*cm[idx]-(Pro[idx]*Nryr)*(gryr)*cj[idx]-Nl[idx]*(glcc)*Pca*2.0*phi*Bca*Cao/(EXP(2.0*phi)-1.0))/(-(Vd*gds)-(Pro[idx]*Nryr)*(gryr)-Nl[idx]*(glcc)*Pca*2.0*phi*EXP(2.0*phi)/(EXP(2.0*phi)-1.0));
				
				//cd[idx]=(-(Vd*gds)*cm[idx]-(Nr[idx])*(gryr)*cj[idx]-Nl[idx]*(glcc)*Pca*2*phi*Bca*Cao/(EXP(2*phi)-1))/(-(Vd*gds)-(Nr[idx])*(gryr)-Nl[idx]*(glcc)*Pca*2*phi*EXP(2*phi)/1000.0/(EXP(2*phi)-1));
				
			}
			else {
				Ilcc[idx]=Nl[idx]*glcc*Pca*(Bca*Cao-EXP(2.0*phi)*cd[idx]);
				
				cd[idx]=(-(Vd*gds)*cm[idx]-(Pro[idx]*Nryr)*(gryr)*cj[idx]-Nl[idx]*(glcc)*Pca*Bca*Cao)/(-(Vd*gds)-(Pro[idx]*Nryr)*(gryr)-Nl[idx]*(glcc)*Pca*EXP(2.0*phi));
				
				//cd[idx]=(-(Vd*gds)*cm[idx]-(Nr[idx])*(gryr)*cj[idx]-Nl[idx]*(glcc)*Pca*Bca*Cao)/(-(Vd*gds)-(Nr[idx])*(gryr)-Nl[idx]*(glcc)*Pca*EXP(2*phi))/1000.0;
			};
			//FluxD=( -gds*(cd[idx]-cm[idx]) + Nr[idx]*gryr*(cj[idx]-cd[idx])/Vd + Ilcc[idx]/Vd );  
#ifndef FIX_SR 
			cj[idx]=cj[idx]+mdt*FluxJ; 
			cs[idx]=cs[idx]+mdt*FluxS;
#endif
			cm[idx]=cm[idx]+mdt*FluxM;
			
			
			
		}
		
		else{
			
			const FLOAT phi=v*F_RT;
			Jncx[idx]=v2*(EXP(nu*phi)*Enai3*Cao-EXP((nu-1)*phi)*Nao3*cm[idx])/(1+POW(Kmca/(cm[idx]),3))/(1+ksat*EXP((nu-1)*phi))/(Kmco*Enai3+Kmno3*cm[idx]+Kmni3*Cao*(1+cm[idx]/Kmci)+Kmci*Nao3*(1+Enai3/Kmni3)+Enai3*Cao+Nao3*cm[idx]);
			
			const FLOAT FluxS=(kappa*(Jup-Jleak))/BuffS;
			const FLOAT FluxM=(-Jup+Jncx[idx]+Jbg+Jleak)/BuffM;
			cm[idx]=cm[idx]+mdt*FluxM;
#ifndef FIX_SR 
	        cs[idx]=cs[idx]+mdt*FluxS;
#endif
			
			
			
		};
	};
	
}
