///////////////////////////////////////////////////////////////////////////////////////////////
//////////////////to use tex
#ifdef USE_TEX
__global__ void tex_myo_diffusion_finitediff_GPU(FLOAT (*cm), FLOAT (*cmtemp), const FLOAT mx, const FLOAT my, const FLOAT mz, const unsigned int nx, const unsigned int ny, const unsigned int nz, const unsigned int nxny, const unsigned int nxnynz, const unsigned int usetemp)
{
  const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  

  if (idx<nxnynz){
    //const FLOAT v = cm[idx];
    FLOAT v;
    FLOAT vn[6];    
    const unsigned int xcoord = (idx)%nx;
    const unsigned int ycoord = int(floorf(idx/nx))%ny;
    const unsigned int zcoord = floorf(idx/nxny);

    int right;
    int left;
    int nxt_row;
    int prv_row;
    int down_coord;
    int up_coord;

    if ( xcoord==nx-1 ) { right= idx-bcshift*1; } else { right=idx+1; };
    if ( xcoord==0 ) { left= idx+bcshift*1; } else { left=idx-1; };
    if ( ycoord==ny-1 ) { nxt_row= idx-bcshift*nx; } else { nxt_row=idx+nx; };
    if ( ycoord==0 ) { prv_row= idx+bcshift*nx; } else { prv_row=idx-nx; };
    if ( zcoord==nz-1 ) { up_coord = idx-bcshift*nxny; } else { up_coord=idx+nxny; };
    if ( zcoord==0 ) { down_coord= idx+bcshift*nxny; } else { down_coord=idx-nxny; };
    
    /*
    #ifdef UN_DIFF_MYO
    //for uncoupled 3D below
     
    if ( xcoord%(UN_SIZE*size_x)==(UN_SIZE*size_x-1) ) { right= idx-bcshift*1; } else { right=idx+1; };
    if ( xcoord%(UN_SIZE*size_x)==0) { left= idx+bcshift*1; } else { left=idx-1; };
    if ( ycoord%(UN_SIZE*size_y)==(UN_SIZE*size_y-1)) { nxt_row= idx-bcshift*nx; } else { nxt_row=idx+nx; };
    if ( ycoord%(UN_SIZE*size_y)==0) { prv_row= idx+bcshift*nx; } else { prv_row=idx-nx; };
    if ( zcoord%(UN_SIZE*size_z)==(UN_SIZE*size_z-1)) { up_coord= idx-bcshift*nxny; } else { up_coord=idx+nxny; };
    if ( zcoord%(UN_SIZE*size_z)==0) { down_coord= idx+bcshift*nxny; } else { down_coord=idx-nxny; };
    
    //for uncoupled 3D above
    #endif
    */

    if (usetemp ==1) {
      v = tex1Dfetch(tex_cmtemp, idx);
      vn[0] = tex1Dfetch(tex_cmtemp, left);
      vn[1] = tex1Dfetch(tex_cmtemp, right);
      vn[2] = tex1Dfetch(tex_cmtemp, prv_row);
      vn[3] = tex1Dfetch(tex_cmtemp, nxt_row);
      vn[4] = tex1Dfetch(tex_cmtemp, down_coord);
      vn[5] = tex1Dfetch(tex_cmtemp, up_coord);
    }
    else {
      v = tex1Dfetch(tex_cm, idx);
      vn[0] = tex1Dfetch(tex_cm, left);
      vn[1] = tex1Dfetch(tex_cm, right);
      vn[2] = tex1Dfetch(tex_cm, prv_row);
      vn[3] = tex1Dfetch(tex_cm, nxt_row);
      vn[4] = tex1Dfetch(tex_cm, down_coord);
      vn[5] = tex1Dfetch(tex_cm, up_coord);   
    }
    
     
    const FLOAT Buff=(1.0+BcdKcd/POW(v+Kcd,2)+BsrKsr/POW(v+Ksr,2));
    FLOAT Mx=mx/Buff;
    FLOAT My=my/Buff;
    FLOAT Mz=mz/Buff;

    // Add the diffusion directly back to the global state.
    const FLOAT tv = 2.0*v;
    cmtemp[idx] = v + Mx*(vn[0]+vn[1]-tv)+My*(vn[2]+vn[3]-tv)+Mz*(vn[4]+vn[5]-tv);
    

 };

}

/////////////////////////////////////////////////////////

__global__ void tex_sr_diffusion_finitediff_GPU(FLOAT (*cs), FLOAT (*cstemp), const FLOAT mx, const FLOAT my, const FLOAT mz, const unsigned int nx, const unsigned int ny, const unsigned int nz, const unsigned int nxny, const unsigned int nxnynz, const unsigned int usetemp)
{
  const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  

  if (idx<nxnynz){
    FLOAT v;
    
    FLOAT vn[6];    
    const unsigned int xcoord = (idx)%nx;
    const unsigned int ycoord = int(floorf(idx/nx))%ny;
    const unsigned int zcoord = floorf(idx/nxny);

    int left = xcoord == 0 ? (idx + bcshift*1) : (idx - 1);
    int right = xcoord == nx-1 ? (idx - bcshift*1) : (idx + 1);
    int prv_row = ycoord == 0 ? (idx + bcshift*nx) : (idx - nx);
    int nxt_row = ycoord == ny-1 ? (idx - bcshift*nx) : (idx + nx);
    int down_coord = zcoord == 0 ? (idx + bcshift*nxny) : (idx - nxny);
    int up_coord = zcoord == nz-1 ? (idx - bcshift*nxny) : (idx + nxny); 

    if (usetemp ==1) {
      v = tex1Dfetch(tex_cstemp, idx);
      vn[0] = tex1Dfetch(tex_cstemp, left);
      vn[1] = tex1Dfetch(tex_cstemp, right);
      vn[2] = tex1Dfetch(tex_cstemp, prv_row);
      vn[3] = tex1Dfetch(tex_cstemp, nxt_row);
      vn[4] = tex1Dfetch(tex_cstemp, down_coord);
      vn[5] = tex1Dfetch(tex_cstemp, up_coord);
    }
    else {
      v = tex1Dfetch(tex_cs, idx);
      vn[0] = tex1Dfetch(tex_cs, left);
      vn[1] = tex1Dfetch(tex_cs, right);
      vn[2] = tex1Dfetch(tex_cs, prv_row);
      vn[3] = tex1Dfetch(tex_cs, nxt_row);
      vn[4] = tex1Dfetch(tex_cs, down_coord);
      vn[5] = tex1Dfetch(tex_cs, up_coord);   
    }

    /*
    #ifdef UN_DIFF_SR
    //for uncoupled 3D below
     
    if ( xcoord%(UN_SIZE*size_x)==(UN_SIZE*size_x-1) ) { right= idx-bcshift*1; } else { right=idx+1; };
    if ( xcoord%(UN_SIZE*size_x)==0) { left= idx+bcshift*1; } else { left=idx-1; };
    if ( ycoord%(UN_SIZE*size_y)==(UN_SIZE*size_y-1)) { nxt_row= idx-bcshift*nx; } else { nxt_row=idx+nx; };
    if ( ycoord%(UN_SIZE*size_y)==0) { prv_row= idx+bcshift*nx; } else { prv_row=idx-nx; };
    if ( zcoord%(UN_SIZE*size_z)==(UN_SIZE*size_z-1)) { up_coord= idx-bcshift*nxny; } else { up_coord=idx+nxny; };
    if ( zcoord%(UN_SIZE*size_z)==0) { down_coord= idx+bcshift*nxny; } else { down_coord=idx-nxny; };
    
    //for uncoupled 3D above
    #endif
    */

    const FLOAT Buff=1.0+BnsrKnsr/POW(v+Knsr,2);
    const FLOAT Mx=mx/Buff;
    const FLOAT My=my/Buff;
    const FLOAT Mz=mz/Buff;

    // Add the diffusion directly back to the global state.
    const FLOAT tv = 2.0*v;
    cstemp[idx] = v + Mx*(vn[0]+vn[1]-tv)+My*(vn[2]+vn[3]-tv)+Mz*(vn[4]+vn[5]-tv);

  };



}

#endif 
////////////////////to use tex













#ifdef BLOCK_SIZE_X

__global__ void
compute_pde(FLOAT* g_idata, FLOAT* v_new, 
            const FLOAT diff, const unsigned int nx, const unsigned int ny, const unsigned int nz, const unsigned int kz, const unsigned int nxny, const unsigned int nxnykz)
{
  // Shared memory for Vm
  __shared__ FLOAT v[BLOCK_SIZE_X][BLOCK_SIZE_Y];
  
  // Diffusion constant
  //const FLOAT d = diff*dt/dx/dx;
  FLOAT Buff=1.0;
  FLOAT d=diff;


  // Access id
  const unsigned int glob_idx = blockIdx.x*blockDim.x + threadIdx.x;
  const unsigned int glob_idy = blockIdx.y*blockDim.y + threadIdx.y;
  //const unsigned int glob_id  = glob_idy*nx + glob_idx;
  const unsigned int glob_id  = nxnykz+glob_idy*nx + glob_idx; 

  // Compute diffusion if threadId is within grid
  if (glob_idx < nx & glob_idy < ny) {
    // Store block data in shared memory.
    v[threadIdx.x][threadIdx.y] = g_idata[glob_id];

    Buff=(1.0+BcdKcd/POW(v[threadIdx.x][threadIdx.y]+Kcd,2)+BsrKsr/POW(v[threadIdx.x][threadIdx.y]+Ksr,2));
    d=diff/Buff;
  }
  
  __syncthreads();
  
  if (glob_idx < nx & glob_idy < ny) {
    // Handle grid boundary conditions (constant flux)
    const int left  = glob_idx == 0    ? (bcshift*1)    : threadIdx.x-1;
    const int right = glob_idx == nx-1 ? (threadIdx.x-bcshift*1) : threadIdx.x+1;
    const int up    = glob_idy == 0    ? (bcshift*1)    : threadIdx.y-1;
    const int down  = glob_idy == ny-1 ? (threadIdx.y-bcshift*1) : threadIdx.y+1;
    const int zdown = kz == 0 ? (glob_id+bcshift*nxny) : glob_id-nxny; 
    const int zup  = kz == nz-1 ? (glob_id-bcshift*nxny) : glob_id+nxny; 
      
    
    FLOAT vdiff = 0.0;      // Storage for the diffusion contribution  
    
    // Handle borders of block.
    vdiff += left == -1 ? g_idata[(glob_id-1)] : v[left][threadIdx.y]; 
    vdiff += right == blockDim.x ? g_idata[(glob_id+1)] : v[right][threadIdx.y];
    vdiff += up == -1 ? g_idata[(glob_id-nx)] : v[threadIdx.x][up];
    vdiff += down == blockDim.y ? g_idata[(glob_id+nx)] : v[threadIdx.x][down];
    vdiff += g_idata[zdown];
    vdiff += g_idata[zup];

    
    
    //v_new[glob_id] += v[threadIdx.x][threadIdx.y]*(1.0 - 6.0*d) + vdiff*d;
     v_new[glob_id] = v[threadIdx.x][threadIdx.y]*(1.0 - 6.0*d) + vdiff*d;
  }
}

//////////////////
__global__ void
compute_pde2(FLOAT* g_idata, FLOAT* v_new, 
            const FLOAT diff, const unsigned int nx, const unsigned int ny, const unsigned int nz, const unsigned int nxny)
{

  for (int kz=0; kz<nz; kz++){
  // Shared memory for Vm
  __shared__ FLOAT v[BLOCK_SIZE_X][BLOCK_SIZE_Y];
  
  // Diffusion constant
  //const FLOAT d = diff*dt/dx/dx;
  FLOAT Buff=1.0;
  FLOAT d=diff;


  // Access id
  const unsigned int glob_idx = blockIdx.x*blockDim.x + threadIdx.x;
  const unsigned int glob_idy = blockIdx.y*blockDim.y + threadIdx.y;
  //const unsigned int glob_id  = glob_idy*nx + glob_idx;
  const unsigned int glob_id  = nxny*kz+glob_idy*nx + glob_idx; 

  // Compute diffusion if threadId is within grid
  if (glob_idx < nx & glob_idy < ny) {
    // Store block data in shared memory.
    v[threadIdx.x][threadIdx.y] = g_idata[glob_id];

    Buff=(1.0+BcdKcd/POW(v[threadIdx.x][threadIdx.y]+Kcd,2)+BsrKsr/POW(v[threadIdx.x][threadIdx.y]+Ksr,2));
    d=diff/Buff;
  }
  
  __syncthreads();
  
  if (glob_idx < nx & glob_idy < ny) {
    // Handle grid boundary conditions (constant flux)
    const int left  = glob_idx == 0    ? (bcshift*1)    : threadIdx.x-1;
    const int right = glob_idx == nx-1 ? (threadIdx.x-bcshift*1) : threadIdx.x+1;
    const int up    = glob_idy == 0    ? (bcshift*1)    : threadIdx.y-1;
    const int down  = glob_idy == ny-1 ? (threadIdx.y-bcshift*1) : threadIdx.y+1;
    const int zdown = kz == 0 ? (glob_id+bcshift*nxny) : glob_id-nxny; 
    const int zup  = kz == nz-1 ? (glob_id-bcshift*nxny) : glob_id+nxny; 
      
    
    FLOAT vdiff = 0.0;      // Storage for the diffusion contribution  
    
    // Handle borders of block.
    vdiff += left == -1 ? g_idata[(glob_id-1)] : v[left][threadIdx.y]; 
    vdiff += right == blockDim.x ? g_idata[(glob_id+1)] : v[right][threadIdx.y];
    vdiff += up == -1 ? g_idata[(glob_id-nx)] : v[threadIdx.x][up];
    vdiff += down == blockDim.y ? g_idata[(glob_id+nx)] : v[threadIdx.x][down];
    vdiff += g_idata[zdown];
    vdiff += g_idata[zup];

    
    
    //v_new[glob_id] += v[threadIdx.x][threadIdx.y]*(1.0 - 6.0*d) + vdiff*d;
     v_new[glob_id] = v[threadIdx.x][threadIdx.y]*(1.0 - 6.0*d) + vdiff*d;
  }
};
}



#endif

///////////////////////////////////////////////////////////////////////////////////////////////
__global__ void myo_diffusion_finitediff_GPU(FLOAT (*cm), FLOAT (*cmtemp), const FLOAT mx, const FLOAT my, const FLOAT mz, const unsigned int nx, const unsigned int ny, const unsigned int nz, const unsigned int nxny, const unsigned int nxnynz)
{
  const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  

  if (idx<nxnynz){
    const FLOAT v = cm[idx];
    const FLOAT tv = 2.0*v;
    FLOAT vn[6];    
    const unsigned int xcoord = (idx)%nx;
    const unsigned int ycoord = int(floorf(idx/nx))%ny;
    const unsigned int zcoord = floorf(idx/nxny);

    int right;
    int left;
    int nxt_row;
    int prv_row;
    int down_coord;
    int up_coord;

    if ( xcoord==nx-1 ) { right= idx-bcshift*1; } else { right=idx+1; };
    if ( xcoord==0 ) { left= idx+bcshift*1; } else { left=idx-1; };
    if ( ycoord==ny-1 ) { nxt_row= idx-bcshift*nx; } else { nxt_row=idx+nx; };
    if ( ycoord==0 ) { prv_row= idx+bcshift*nx; } else { prv_row=idx-nx; };
    if ( zcoord==nz-1 ) { up_coord = idx-bcshift*nxny; } else { up_coord=idx+nxny; };
    if ( zcoord==0 ) { down_coord= idx+bcshift*nxny; } else { down_coord=idx-nxny; };
    

    //~ #ifdef UN_DIFF_MYO
    //~ //for uncoupled 3D below
     //~ 
    //~ if ( xcoord%(UN_SIZE*size_x)==(UN_SIZE*size_x-1) ) { right= idx-bcshift*1; } else { right=idx+1; };
    //~ if ( xcoord%(UN_SIZE*size_x)==0) { left= idx+bcshift*1; } else { left=idx-1; };
    //~ if ( ycoord%(UN_SIZE*size_y)==(UN_SIZE*size_y-1)) { nxt_row= idx-bcshift*nx; } else { nxt_row=idx+nx; };
    //~ if ( ycoord%(UN_SIZE*size_y)==0) { prv_row= idx+bcshift*nx; } else { prv_row=idx-nx; };
    //~ if ( zcoord%(UN_SIZE*size_z)==(UN_SIZE*size_z-1)) { up_coord= idx-bcshift*nxny; } else { up_coord=idx+nxny; };
    //~ if ( zcoord%(UN_SIZE*size_z)==0) { down_coord= idx+bcshift*nxny; } else { down_coord=idx-nxny; };
    //~ 
    //~ //for uncoupled 3D above
    //~ #endif
    
    vn[0] = cm[left];      
    vn[1] = cm[right];
    vn[2] = cm[prv_row];
    vn[3] = cm[nxt_row];
    vn[4] = cm[down_coord];
    vn[5] = cm[up_coord];
    
     
    const FLOAT Buff=(1.0+BcdKcd/POW(cm[idx]+Kcd,2)+BsrKsr/POW(cm[idx]+Ksr,2));
    FLOAT Mx=mx/Buff;
    FLOAT My=my/Buff;
    FLOAT Mz=mz/Buff;

    // Add the diffusion directly back to the global state.
    cmtemp[idx] = v + Mx*(vn[0]+vn[1]-tv)+My*(vn[2]+vn[3]-tv)+Mz*(vn[4]+vn[5]-tv);
    

 };

}

/////////////////////////////////////////////////////////

__global__ void sr_diffusion_finitediff_GPU(FLOAT (*cs), FLOAT (*cstemp), const FLOAT mx, const FLOAT my, const FLOAT mz, const unsigned int nx, const unsigned int ny, const unsigned int nz, const unsigned int nxny, const unsigned int nxnynz)
{
  const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  

  if (idx<nxnynz){
    const FLOAT v = cs[idx];
    const FLOAT tv = 2.0*v;
    FLOAT vn[6];    
    const unsigned int xcoord = (idx)%nx;
    const unsigned int ycoord = int(floorf(idx/nx))%ny;
    const unsigned int zcoord = floorf(idx/nxny);

    int left = xcoord == 0 ? (idx + bcshift*1) : (idx - 1);
    int right = xcoord == nx-1 ? (idx - bcshift*1) : (idx + 1);
    int prv_row = ycoord == 0 ? (idx + bcshift*nx) : (idx - nx);
    int nxt_row = ycoord == ny-1 ? (idx - bcshift*nx) : (idx + nx);
    int down_coord = zcoord == 0 ? (idx + bcshift*nxny) : (idx - nxny);
    int up_coord = zcoord == nz-1 ? (idx - bcshift*nxny) : (idx + nxny); 

    /*//for uncoupled 2D below DONT USE IN 3D
     
    if ( xcoord%(size_x)==(size_x-1) ) { right= idx-bcshift*1; } else { right=idx+1; };
    if ( xcoord%(size_x)==0) { left= idx+bcshift*1; } else { left=idx-1; };
    if ( ycoord%(size_y)==(size_y-1)) { nxt_row= idx-bcshift*nx; } else { nxt_row=idx+nx; };
    if ( ycoord%(size_y)==0) { prv_row= idx+bcshift*nx; } else { prv_row=idx-nx; };
    
    *///for uncoupled 2D above

    #ifdef UN_DIFF_SR
    //for uncoupled 3D below
     
    if ( xcoord%(UN_SIZE*size_x)==(UN_SIZE*size_x-1) ) { right= idx-bcshift*1; } else { right=idx+1; };
    if ( xcoord%(UN_SIZE*size_x)==0) { left= idx+bcshift*1; } else { left=idx-1; };
    if ( ycoord%(UN_SIZE*size_y)==(UN_SIZE*size_y-1)) { nxt_row= idx-bcshift*nx; } else { nxt_row=idx+nx; };
    if ( ycoord%(UN_SIZE*size_y)==0) { prv_row= idx+bcshift*nx; } else { prv_row=idx-nx; };
    if ( zcoord%(UN_SIZE*size_z)==(UN_SIZE*size_z-1)) { up_coord= idx-bcshift*nxny; } else { up_coord=idx+nxny; };
    if ( zcoord%(UN_SIZE*size_z)==0) { down_coord= idx+bcshift*nxny; } else { down_coord=idx-nxny; };
    
    //for uncoupled 3D above
    #endif

    vn[0] = cs[left];      
    vn[1] = cs[right];
    vn[2] = cs[prv_row];
    vn[3] = cs[nxt_row];
    vn[4] = cs[down_coord];
    vn[5] = cs[up_coord];

    const FLOAT Buff=1.0+BnsrKnsr/POW(cs[idx]+Knsr,2);
    const FLOAT Mx=mx/Buff;
    const FLOAT My=my/Buff;
    const FLOAT Mz=mz/Buff;

    // Add the diffusion directly back to the global state.
    cstemp[idx] = v + Mx*(vn[0]+vn[1]-tv)+My*(vn[2]+vn[3]-tv)+Mz*(vn[4]+vn[5]-tv);

  };



}

////////////////////////////////////////////////////////////////////////////////////////////


__global__ void stateUpdate(FLOAT (*cm), FLOAT (*cmtemp),const unsigned int nxnynz)
{
  const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  
  if (idx<nxnynz){
   cm[idx]=cmtemp[idx]; 
  };
}





//////////////////////////////////////////////////////////////////////////////////////////

__global__ void sr_size_copy(FLOAT (*csB), FLOAT (*cs), const unsigned int nx, const unsigned int ny, const unsigned int nz, const unsigned int nxny, const unsigned int nxnynz)
{
  const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  
  if (idx<nxnynz){
   int xcoord = (idx)%nx;
   int ycoord = int(floorf(idx/nx))%ny;
   int zcoord = floorf(idx/nxny);

   cs[idx]=csB[Numx*Numy*int(floorf(zcoord/size_z)) +Numx*int(floorf(ycoord/size_y)) + int(floorf(xcoord/size_x))];
    
  };
}

//////////////////////////////////////////////////////////////////////////////////////////

__global__ void sr_size_copy_back(FLOAT (*csB), FLOAT (*cs), const unsigned int nx, const unsigned int ny, const unsigned int nz, const unsigned int nxny, const unsigned int nxnynz)
{
  const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  
  if (idx<nxnynz){
   int xcoord = (idx)%nx;
   int ycoord = int(floorf(idx/nx))%ny;
   int zcoord = floorf(idx/nxny);

   csB[Numx*Numy*int(floorf(zcoord/size_z)) +Numx*int(floorf(ycoord/size_y)) + int(floorf(xcoord/size_x))]=cs[idx];
    
  };
}

