
#define TperB 128

//#define BLOCK_SIZE_X 16 //define to use 2d block structure
//#define BLOCK_SIZE_Y  8

#define FLOAT float //must also change this in cru_reduction_gpu.h

#define EXP __expf //could conflict with ucla.h
#define LOG __logf
#define POW __powf

/* //define to use textured memory for diffusion (double not supported)
#define USE_TEX 
texture<FLOAT> tex_cm;
texture<FLOAT> tex_cmtemp;
texture<FLOAT> tex_cs;
texture<FLOAT> tex_cstemp;
*/


//for uniform grid
#define Numx 100 //make multiples of 2*size_x,size_y,size_z
#define Numy 20
#define Numz 10
#define size_x 5
#define size_y 5 
#define size_z 5
#define dx 0.2//(1.0/size_x)
#define xtest ((size_x+1)/2-1)
#define ytest ((size_y+1)/2-1)
#define ztest ((size_z+1)/2-1)
#define Nx ((Numx*size_x)) 
#define Ny ((Numy*size_y)) 
#define Nz (Numz*size_z) 
#define NxNyNz (Nx*Ny*Nz) 
#define NxNy (Nx*Ny) 
#define NxNyNz_size (Numx*Numy*Numz/2+2*Numx*Numy+2*Numx*Numz)

//#define CRUSPACE 4 //do not define for normal cru spacing of 5 (see funmaker_uniform)

#define bcshift 1// 0 is for reflecting bc (normal bc for cell, would be 1 for tissue)

//Ndiff=<Nflux, Nflux must be multiple of Ndiff
#define dt 0.01 //0.01 //largest time step used for ap
#define Ndiff 1 //diffusion steps (dtdiff must be smaller than dt and larger than dtflux)
#define dtdiff (dt/Ndiff)
#define Nflux 1 //flux steps (should be divisible by Ndiff)
#define dtflux (dt/Nflux)
#define Nflux_Ndiff (Nflux/Ndiff)


#define F 96.5 
#define R 8.314 
#define T 310.0 
#define F_RT (F/(R*T))

#define numNcx 0.5//(0.5)//0.25
#define numJbg 1.0
#define numup 1.0//1.0
#define numryr (1.0)//1.0

#define v2 (numNcx*0.8)//0.8//0.4 
#define Vj 0.1 
#define Vd (0.00126) //0.00126 

#define ksat 0.27 
#define nu 0.35 
#define gds  (0.303/0.00126)//0.303 //divided by original dyadic space volume to get value to agree with robert
#define gjsr 1.0 //0.1  //divided by original jsr volume to get value to agree with robert
#define zetas (0.2/size_x/size_y/size_z)//(0.008/size_z)//0.2  
#define zetam (5.0/size_x/size_y/size_z)//(0.2/size_z)//5.0 
#define kappa (zetam/zetas)  
#define Kmca 0.11  
#define Kmno 87.5  

#define DxM (0.3)//0.3//0.35
#define DyM DxM//(DxM/2.0)//0.15 
#define DzM DxM//(DxM/2.0)//0.15 
#define DxS 0.06 //1.4 
#define DyS DxS //1.4 
#define DzS DxS //1.4 
#define DxSdt_dx2 (DxS*dtdiff/dx/dx) //for finite diff
#define DySdt_dx2 (DyS*dtdiff/dx/dx) 
#define DzSdt_dx2 (DzS*dtdiff/dx/dx) 
#define DxMdt_dx2 (DxM*dtdiff/dx/dx) //for finite diff
#define DyMdt_dx2 (DyM*dtdiff/dx/dx) 
#define DzMdt_dx2 (DzM*dtdiff/dx/dx) 


#define Bcd (15.0) //15.0 //24.0//15.0 //calmodulin buffer in myo
#define Kcd 13.0 //7.0//13.0 
#define BcdKcd (Bcd*Kcd) 
#define Bsr (7.0) //7.0 //19.0//7.0 //myoplasmic buffer
#define Ksr 0.3 //0.6//0.3 
#define BsrKsr (Bsr*Ksr) 
#define Bnsr 140.0//140.0 // sr buffer
#define Knsr 650.0 
#define BnsrKnsr (Bnsr*Knsr) 
// old buffers
#define Bmca 140.0
#define Kmmca 0.033
#define BmcaKmmca (Bmca*Kmmca)
#define Bmmg 140.0
#define Kmmg 3.64
#define BmmgKmmg (Bmmg*Kmmg)



#define Kmci 3.59
#define kmci 0.00359  
#define Kmni 12.3  

#define Pca 0.000913  
#define kap (0.7*0.005)//(0.7*0.005)  
#define kam (1.0)
#define kbm (0.003)//0.003//
#define kbmr2c (kbm) //use to just change r to c rate, does not preserve detailed balance
#define kbp (0.00075)//
#define a1 0.15
#define a2 0.30
#define b1 22.0
#define b2 0.4255
#define gbg (numJbg*0.0002/5.0)
#define gca (0.00003)//(0.00003)//(0.000017)  
#define vup (numup*0.32)  

#define Nao (136.0) //136.0  
#define Nai (11.0)//10.0//(78.0/(1.0+10.0*sqrt(PCL/1000.0)))//10.0//(78.0/(1.0+10.0*sqrt(PCL/1000.0)))  
#define Kmco 1300 
#define kmco 1.3 


#define gryr (numryr*0.000205) //0.000205  
#define glcc (numlcc*1.0)  
#define Bca 0.341  
#define kup (1.0) //1.0//0.123//1.0  
#define Nai3 (Nai*Nai*Nai) 
#define Nao3 (Nao*Nao*Nao) 
#define Kmno3 (Kmno*Kmno*Kmno) 
#define Kmni3 (Kmni*Kmni*Kmni) 

#define cdbar 0.5//3.0
#define k2 0.0001
#define TBa 450.0 
#define k1p 0.00413 
#define rr1 0.3 
#define rr2 (3.0)//3.0 
#define k2p 0.00224 
#define s1p 0.00195 
#define s2p (s1p*(k2p/k1p)*(rr1/rr2));



//////below to compute single spark plots 
#define Spark_Plot
#define OUTPUT_ALL
#define SparkZ 2//2//2 //int(ztest +floorf(Numz/2)*size_z)
#define SparkY 2//CRUSPACE//2 //int(ytest +floorf(Numy/2)*size_y)
#define SparkX 2//CRUSPACE//CRUSPACE//2 //int(xtest +floorf(Numx/2)*size_x)
#define SparkZ2 2//2//2 //int(ztest +floorf(Numz/2)*size_z)
#define SparkY2 2//CRUSPACE//2 //int(ytest +floorf(Numy/2)*size_y)
#define SparkX2 7//(2*CRUSPACE)//7 //int(xtest +floorf(Numx/2)*size_x)

////////////these are used in main_CRU.cu for FluxUpdate_GPU and RyrUpdate_GPU to change from stochastic RYR to ODE RYR
#define USE_RYR_RAND
//#define USE_RYR_ODE 

/////////////in main_CRU.cu to do LCC7state update
#define USE_LCC_RAND

///////////////to do diffusion steps
#define DO_DIFFUSION

//////////////to do flux steps
#define DO_FLUX

///////////////these are for making a spark in Lcc7stateUpdate at time MAKE_SPARK
/*#define MAKE_SPARK 1000 
#define SPARK_DUR 10
#define SPARKX_START (10*5)//(CRU start of spark)*5
#define SPARKX_END (10*5+xtest+9*5)//(CRU start of spark)*5 +xtest+(Length of spark-1)*5
#define SPARKY_START (2*5)//(int(ytest +floorf(Numy/2)*size_y)-(8*size_y))
#define SPARKY_END (2*5+ytest+9*5)//(int(ytest +floorf(Numy/2)*size_y)+(8*size_y))
#define SPARKZ_START 2//(int(ztest +floorf(Numz/2)*size_z)-(8*size_z))
#define SPARKZ_END 2//(int(ztest +floorf(Numz/2)*size_z)+(8*size_z))
*/

/////////////these are used in diffusion_finitediff_GPU.h to uncouple CRUs in myo and/or sr
///////////// note: need to change Nx, Ny, and Nz too
//#define UN_DIFF_MYO
//#define UN_DIFF_SR
//#define UN_SIZE 1


////////to do NUM_DT_SR extra steps for sr diffusion 
//#define NUM_DT_SR 5

/////////////// fixed AP

//#define DO_FIXED_AP 
#define vrest -80.0
#define PCL 500.0
#define APD 200.0//200.0//((2.0/3.0)/(PCL/1000.0+(2.0/3.0))*PCL)//200.0 
//#define STOP_FIXED_AP (10000) //define to stop pacing at the indicated time



/////////////// dynamic ucla AP model

#define DO_UCLA_AP
#define USE_CA_CELL // mod out to run ucla model independent of cell model
#define USE_LCC_CELL // mod out to use ucla lcc flux with my Nl/Nlcc for Po, otherwise the local lcc flux is used
#define Vucla -87.2514
#define H_EULER  0.1 //0.1 //not used
#define DT_STIM  1.0
#define I_STIM  40.0//40.0
#define nStim int(DT_STIM/H_EULER)
#define EULER_STIM_MULT 10 //not used
#define uclaPCL 1000 //200
#define uclaAPstep int(H_EULER/dt)
#define TS_ADAPT_FCT 1 // Time step adaptation, enno had set at 10
#define DVDT_MAX 25.0  // mV
#define vrest Vucla  


//define to output voltage to ap_clamp_file, define with an ap above
/*
#define AP_CLAMP_FILE "Data_Sets_GPU_cru/ap_clamp_file_normal_500_b69"
#define AP_REC_START 19000
#define AP_REC_STOP (AP_REC_START+uclaPCL)
#define AP_OUTSTEP int(dt/dt)
*/

//define to use AP clamp from file AP_CLAMP (undefine other APs above, and undefine AP_CLAMP_FILE)

//#define AP_CLAMP "Data_Sets_GPU_cru/ap_clamp_file_normal_500_b69"
//#define PCL 1800 //what was used to make ap_file 
//#define vrest -87.2514 //ap_clamp_file[0] is used, but need to define vrest anyway
//#define AP_OUTTIME dt //outtime used to make ap_file
//#define STOP_FIXED_AP (10250) //define to stop pacing at the indicated time


#define naiIC Nai //for ucla, not sure if this works??
//#define CLAMP_NAI //to fix Nai during ucla sim 
#define wca 8.0313
#define vap 0.0 //0.0//10.0//10.0  
#define numlcc (2.0) //2.0
#define gleak (0.000004) //0.000004
//#define gbgconst (1.0*(0.0002/5.0)) //0.0002/5.0 (0 is  normal, just undefine to remove from fluxupdate instead)
#define cmIC 0.1
#define csIC 700.0 //750.0
#define Cao (1800.0)//1800.0//1800.0  
#define cao (Cao/1000.0)
#define Nryr 100 //100

#define Nlcc (10) //10
//#define VAR_LCC 10 //to make a variable number of lcc: remove VAR_LCC and put VAR_LCC on neighbor
//#define REMOVE_LCC// to remove lccs from half the crus without adding to others, need to use with var_lcc and make !!!!!!!VAR_LCC=0 !!!!!!!!

//define below to randomly distribute TTs
//#define TTdisrupt //randomly distribute half the LCCs out of the ds, but leave half of Nlcc in DS of every CRU
//#define DISRUPT_ALL_TT //to randomly distribute all LCCs in and out of ds's (need to also define TTdisrupt above)
//#define plcc 0.3 //define to put an Nlcc cluster in ds with prob=1-plcc, otherwise in myo (do not define TTdisrupt above)
//#define plcc_REMOVE //define with plcc above to remove instead of move

/////////fix SR and jSR load
//#define FIX_SR csIC

////////fix SR and jSR load untill time UNFIX_SR_TIME (also must use FIX_SR above)
//#define UNFIX_SR_TIME MAKE_SPARK-1

#define tottime 300 //1000//100005 //20010  
#define step_tot int(tottime/dt) 

//#define DO_OUTPUT_FAST //to do fast output define and undefine DO_OUTPUT
//#define DO_OUTPUT
//#define outstep int(5/dt) //int(5/dt)
//#define APoutstep int(1/dt) //outstep not used
//#define moviestep (outstep) //(3*outstep)



//////below to compute spark waittimes
/*
#define COMPUTE_SPARK_T 0
#define SPARK_U_T 20//20
#define SPARK_L_T 1//1
*/


///////// FOR MOVIES ///////////////
#define DX_SAMPLE     1
#define DY_SAMPLE     1
#define MAXBUFSIZE   1 
#define REC_N_CELLS   Nx*Ny/DX_SAMPLE/DY_SAMPLE
#define MIN_VAR_DIFF  0.00001//FLT_MIN*UCHAR_MAX
#define MovieZ (0)

//to make movies define below

//#define BMOVIETIME  10000//14000//0
//#define EMOVIETIME  20000//15000//tottime-10//(BMOVIETIME+floorf(2000.0/(outstep*dt))*outstep*dt)
//#define SR_MOVIE //define to output sr moive, undefine to output cm movie

//below to output whole cm data (dont use anymore)
//#define BCLUSTERTIME -1//5000
//#define ECLUSTERTIME -1//6000
//#define clusterstep (100*outstep)

#define DevNum 3
#define MOVIE_FILE    "Data_Sets_GPU_cru/spiral_f127.bin"
#define BOUNDS_FILE   "Data_Sets_GPU_cru/spiral_f127.vmm"
#define AVG_FILE "Data_Sets_GPU_cru/avgfile_f127"
#define SPARK_FILE "Data_Sets_GPU_cru/sparkfile_f127"
#define SINGLE_SPARK_FILE "Data_Sets_GPU_cru/singlesparkfile_f127"









